// File: CryptoClientInter.java

package Encryption;

import com.visigenic.vbroker.interceptor.*;
import com.visigenic.vbroker.IOP.*;
import com.visigenic.vbroker.GIOP.*;
import com.visigenic.vbroker.orb.*;
import org.omg.CORBA.*;
import org.omg.CORBA.portable.*;

public class CryptoClientInter extends Crypto implements ClientInterceptor
{
  public CryptoClientInter(com.visigenic.vbroker.orb.ORB orb) 
  {
    super("ClientINT", orb);
  }

  public void prepare_request(RequestHeaderHolder request, Closure closure)
  {
    interceptPrint("prepare_request");
  }
  
  public OutputStream send_request(RequestHeader request, OutputStream buf,
				   Closure closure)
  {
    interceptPrint("send_request");
    return encrypt(buf, ENCRYPTION_KEY_REQUEST);
  }

  public void send_request_failed(RequestHeader request, Environment env,
				  Closure closure) 
  {
    interceptPrint("send_request_failed");
  }

  public void send_request_succeeded(RequestHeader request, Closure closure)
  {
    interceptPrint("send_request_succeeded");
  }

  public InputStream receive_reply(ReplyHeader reply, InputStream buf, 
				   Environment env, Closure closure)
  {
    interceptPrint("receive_reply");
    if ((reply.reply_status.value() == ReplyStatusType._USER_EXCEPTION) || 
       (reply.reply_status.value() == ReplyStatusType._SYSTEM_EXCEPTION)) {
      // Don't decrypt an exception
      return null;
    } else {
      return decrypt(buf);
    }
  }

  public void receive_reply_failed(int i, Environment env,
				   Closure closure)
  {
    interceptPrint("receive_reply_failed");
  }

  public void exception_occurred(int i, Environment env,
				 Closure closure)
  {
    interceptPrint("exception_occurred");
    if (env != null) {
      System.out.println(env.exception());
    }
  }
}
