// Client.java

import com.visigenic.vbroker.interceptor.*;

class MyClientEventHandler implements ClientEventHandler {

  private String _name;

  MyClientEventHandler(String name) {
    _name = name;
  }

  public void bind_succeeded(org.omg.CORBA.Object obj, ConnectionInfo info) {
    System.out.println(_name + ": bind_succeeded: " + obj + " info: " + toString(info));
  }

  public void bind_failed(org.omg.CORBA.Object obj) {
    System.out.println(_name + ": bind_failed: " + obj);
  }

  public void server_aborted(org.omg.CORBA.Object obj) {
    System.out.println(_name + ": server_aborted: " + obj);
  }

  public void rebind_succeeded(org.omg.CORBA.Object obj, ConnectionInfo info) {
    System.out.println(_name + ": rebind_succeeded: " + obj + " info: " + toString(info));
  }

  public void rebind_failed(org.omg.CORBA.Object obj) {
    System.out.println(_name + ": rebind_failed: " + obj);
  }

  private String toString(ConnectionInfo info) {
    return "ConnectionInfo[hostname=" + info.hostname +
      ",port=" + info.port + "]";
  }

}

public class Client {

  public static void main(String[] args) {
    try {
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);
      // com.visigenic.vbroker.ds.DSUser.debug = true;
      HandlerRegistry registry = HandlerRegistryHelper.narrow(
	orb.resolve_initial_references("HandlerRegistry"));
      registry.reg_glob_client_handler
	(new MyClientEventHandler("global"));
      Bank.AccountManager manager = 
	Bank.AccountManagerHelper.bind(orb, "BankManager");
      registry.reg_obj_client_handler
	(manager, new MyClientEventHandler("object"));
      Bank.Account account = manager.open("Jack B. Quick");
      System.out.println("The balance is $" + account.balance());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
}
