// TimerClientInterceptor.java

package timer;

import com.visigenic.vbroker.interceptor.*;
import com.visigenic.vbroker.GIOP.*;

public class TimerClientInterceptor extends TimerInterceptor implements ClientInterceptor
{
    public void prepare_request(RequestHeaderHolder hdr, Closure closure)
    {
        begin(closure, ((RequestHeader)hdr.value).operation);
    }

    public org.omg.CORBA.portable.OutputStream send_request(RequestHeader hdr, org.omg.CORBA.portable.OutputStream buf, Closure closure)
    {
        delta(closure, "prepare time");
        return null;
    }

    public void send_request_failed(RequestHeader hdr, org.omg.CORBA.Environment env, Closure closure)
    {
        delta(closure, "send time");
    }

    public void send_request_succeeded(RequestHeader hdr, Closure closure)
    {
        delta(closure, "send time");
    }

    public org.omg.CORBA.portable.InputStream receive_reply(ReplyHeader hdr, org.omg.CORBA.portable.InputStream buf, org.omg.CORBA.Environment env, Closure closure)
    {
        delta(closure, "receive time");
        complete(closure, "total call");
        return null;
    }

    public void receive_reply_failed(int req_id, org.omg.CORBA.Environment env, Closure closure)
    {
        delta(closure, "receive time");
        complete(closure, "total call");
    }

    public void exception_occurred(int req_id, org.omg.CORBA.Environment env, Closure closure)
    {
    }
}
