package BankWrappers;

import java.util.*;
import com.visigenic.vbroker.orb.*;
import com.visigenic.vbroker.interceptor.*;

public class Init extends ServiceInit {
  com.visigenic.vbroker.orb.ORB _orb;

  public void init(org.omg.CORBA.ORB orb, Properties properties) {
    _orb = (ORB) orb;

    // install my CachingAccountObjectWrapper
    String val = properties.getProperty("CachingAccount", this.toString());
    Class c = CachingAccountObjectWrapper.class;
    if( !val.equals(this.toString())) {
      if( val.equalsIgnoreCase("client") ){
	Bank.AccountHelper.addClientObjectWrapperClass(orb, c);
      } else if( val.equalsIgnoreCase("server") ) {
	Bank.AccountHelper.addServerObjectWrapperClass(orb, c);
      } else {
	Bank.AccountHelper.addClientObjectWrapperClass(orb, c);
	Bank.AccountHelper.addServerObjectWrapperClass(orb, c);
      }
    }

    // install my CachingAccountManagerObjectWrapper
    val = properties.getProperty("CachingAccountManager", 
					this.toString());
    c = CachingAccountManagerObjectWrapper.class;
    if( !val.equals(this.toString())) {
      if( val.equalsIgnoreCase("client") ){
	Bank.AccountManagerHelper.addClientObjectWrapperClass(orb, c);
      } else if( val.equalsIgnoreCase("server") ) {
	Bank.AccountManagerHelper.addServerObjectWrapperClass(orb, c);
      } else {
	Bank.AccountManagerHelper.addClientObjectWrapperClass(orb, c);
	Bank.AccountManagerHelper.addServerObjectWrapperClass(orb, c);
      }
    }

    // install my CachingAccountManagerObjectWrapper
    val = properties.getProperty("SecureAccountManager", 
					this.toString());
    c = SecureAccountManagerObjectWrapper.class;
    if( !val.equals(this.toString())) {
      if( val.equalsIgnoreCase("client") ){
	Bank.AccountManagerHelper.addClientObjectWrapperClass(orb, c);
      } else if( val.equalsIgnoreCase("server") ) {
	Bank.AccountManagerHelper.addServerObjectWrapperClass(orb, c);
      } else {
	Bank.AccountManagerHelper.addClientObjectWrapperClass(orb, c);
	Bank.AccountManagerHelper.addServerObjectWrapperClass(orb, c);
      }
    }

  }
}
