// Client.java

public class Client {

  public static void test(org.omg.CORBA.ORB orb, int count) {
    long beforeBind = System.currentTimeMillis();
    Bank.AccountManager manager = 
      Bank.AccountManagerHelper.bind(orb, "BankManager");
    long afterBind = System.currentTimeMillis();
    System.out.println("  Time for bind call: " + 
		       (afterBind - beforeBind) + " mS");
    long beforeInvoke = System.currentTimeMillis();
    for(int i = 0; i < count; i++) {
      Bank.Account account = manager.open("Corba the Geek");
      float balance = account.balance();
    }
    long afterInvoke = System.currentTimeMillis();
    System.out.println("  Avg time for " + count + " open/balance calls: " + 
		       (afterInvoke - beforeInvoke) / (float) count + " mS");
  }


  public static void main(String[] args) {
    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);
    System.out.println("\nInvoking the first time:");
    test(orb, 1);
    System.out.println("\nInvoking with normal proxies:");
    test(orb, 100);
    System.out.println("\nInvoking with smart proxies:");
    Bank.AccountHelper.setStubClass(SmartAccount.class);
    Bank.AccountManagerHelper.setStubClass(SmartAccountManager.class);
    test(orb, 100);
  }

}
